VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsTCADX"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'******************************************************************'
'*                                                                *'
'*                      TurboCAD for Windows                      *'
'*                   Copyright (c) 1993 - 2001                    *'
'*             International Microcomputer Software, Inc.         *'
'*                            (IMSI)                              *'
'*                      All rights reserved.                      *'
'*                                                                *'
'******************************************************************'

Option Explicit

Private gxApp As XApplication
Private gxDwg As XDrawing
Private gxView As View

Private bInit As Boolean
Private idEvents As Long
Private events As New dlgTCADEvents
Private dwgs As New dlgDrawings

Public Function CreateTCApp() As Boolean
    On Error GoTo RunTCAD
    
    Set gxApp = GetObject(, "TurboCAD.Application")
    bInit = True
    gxApp.Visible = True
    CreateTCApp = True
    Exit Function
RunTCAD:
    On Error GoTo Error
    Set gxApp = CreateObject("TurboCAD.Application")
    gxApp.Visible = True
    bInit = True
    CreateTCApp = True
    Exit Function
Error:
    CreateTCApp = False
End Function

Private Sub Class_Initialize()
    bInit = False
    idEvents = -1
End Sub

Private Sub Class_Terminate()
    
    DisconnectEvents
    Unload events
    DetachDrawing
    Set gxApp = Nothing
End Sub

Public Function CreateGXApp()
    
     On Error GoTo Error
     Set gxApp = CreateObject("IMSIGX.Application")
     bInit = True
     CreateGXApp = True
     Exit Function
Error:
    CreateGXApp = False
End Function


Public Sub ConnectEvents()

    DisconnectEvents
    
    Dim mask As Long

    events.Show vbModal, frmTCADX

    If (events.bOK) Then
        If (events.mask <> 0) Then
            idEvents = gxApp.ConnectEvents(events, events.mask)
        End If
    End If
End Sub

Public Sub DisconnectEvents()

    If (idEvents <> -1) Then
        gxApp.DisconnectEvents idEvents
        idEvents = -1
    End If

End Sub

Public Function AttachToDrawing(hwnd As Long) As Boolean

    Dim gxDwgs As Drawings
    Dim nCnt As Long
    Dim indItem As Long
   
    Set gxDwgs = gxApp.Drawings
    nCnt = gxDwgs.Count() - 1
    
    dwgs.lstDwgs.Clear
    AttachToDrawing = False
    For indItem = 0 To nCnt
    
        dwgs.lstDwgs.AddItem gxDwgs(indItem).Name
    
    Next indItem

    dwgs.Show vbModal

    If (dwgs.bOK) Then
        DetachDrawing
        Set gxDwg = gxDwgs(dwgs.indDwg)
        Set gxView = gxDwg.Views.Add(hwnd)
    End If

    On Error GoTo Err:
    gxView.ZoomToExtents
    AttachToDrawing = True
    Exit Function
Err:
End Function

Public Sub DetachDrawing()

    On Error Resume Next
    gxView.Delete
    Set gxView = Nothing
    Set gxDwg = Nothing

End Sub

Public Sub Refresh()
    On Error Resume Next
    gxView.Refresh
End Sub

Public Sub Scroll(dx As Long, dy As Long)

    Dim dxView As Long
    Dim dyView As Long
    
    Dim yTop As Double
    Dim xLeft As Double
    
    On Error GoTo Err
    
    xLeft = gxView.ViewLeft + gxView.ViewWidth() * dx / 10
    yTop = gxView.ViewTop - gxView.ViewHeight() * dy / 10
    
    gxView.Update = False
    
    gxView.ViewLeft = xLeft
    gxView.ViewTop = yTop

Err:
End Sub

Public Sub Zoom(factor As Double)

    If (factor <> 0) Then
        Dim xC As Double
        Dim yC As Double
        
        Dim w As Double
        Dim h As Double
    
        w = gxView.ViewWidth
        h = gxView.ViewHeight
    
        xC = gxView.ViewLeft + w / 2
        yC = gxView.ViewTop - h / 2
    
        w = w * factor
        h = h * factor
    
        gxView.Update = False
        
        gxView.ViewLeft = xC - w / 2
        gxView.ViewTop = yC + h / 2
    
        gxView.ViewWidth = w
        gxView.ViewHeight = h
    Else
        gxView.ZoomToExtents
    End If

End Sub

Public Function SelectByClick(X As Single, Y As Single, bSelect As Boolean) As Boolean
    Dim XScreen As Double
    Dim YScreen As Double
    
    Dim XView As Double
    Dim YView As Double
    
    Dim gxPickResult As PickResult
    Dim nCnt As Long
    Dim indItem As Long
    
    XScreen = X
    YScreen = Y
    
    SelectByClick = False
    On Error GoTo Err

    If (X >= 0 And Y >= 0) Then
        gxView.ScreenToView XScreen, YScreen, XView, YView
    
        Set gxPickResult = gxView.PickPoint(XView, YView)
    
        nCnt = gxPickResult.Count - 1
        
        
        For indItem = 0 To nCnt
        
            If (bSelect) Then
                gxPickResult(indItem).Graphic.Select
            Else
                gxPickResult(indItem).Graphic.Unselect
            End If
        
        Next indItem
    End If
    
    SelectByClick = (gxDwg.Selection.Count() > 0)
    Exit Function
Err:
End Function

Public Sub ScaleSelection(fScale As Double, bUseSelBBox As Boolean)

    Dim gxSel As Selection
    Dim gxGr As Graphic
    Dim gxMx As Matrix
    Dim gxSelBBox As BoundingBox
    Dim gxVrtMin As Vertex
    Dim gxVrtMax As Vertex
    
    Set gxSel = gxDwg.Selection
    
    Dim XRef As Double, YRef As Double, ZRef As Double
    
    If (bUseSelBBox) Then
        GetRefPoint gxSel, XRef, YRef, ZRef
    End If
    

    For Each gxGr In gxSel

        If (bUseSelBBox) Then
            Set gxMx = gxGr.Scale(fScale, fScale, fScale, XRef, YRef, ZRef)
        Else
            Set gxMx = gxGr.Scale(fScale, fScale, fScale)
        End If
    
    Next

    gxSel(0).Select
End Sub

Public Sub MoveSelectionToClick(X As Single, Y As Single, bUseSelBBox As Boolean)

    Dim XScreen As Double
    Dim YScreen As Double
    
    Dim XView As Double
    Dim YView As Double

    Dim XWorld As Double
    Dim YWorld As Double
    Dim ZWorld As Double
    
    Dim XUcs As Double
    Dim YUcs As Double
    Dim ZUcs As Double

    Dim XRef As Double
    Dim YRef As Double
    Dim ZRef As Double
    
    Dim XRefUcs As Double
    Dim YRefUcs As Double
    Dim ZRefUcs As Double
    
    Dim gxGr As Graphic
    Dim gxSel As Selection
    Dim gxMx As Matrix
    
    On Error GoTo Err
    
    XScreen = X
    YScreen = Y
    
    gxView.ScreenToView XScreen, YScreen, XView, YView
    gxView.ViewToWorld XView, YView, 0, XWorld, YWorld, ZWorld

    Set gxSel = gxDwg.Selection
    
    If (bUseSelBBox) Then
    
        GetRefPoint gxSel, XRef, YRef, ZRef
    
        For Each gxGr In gxSel
        
            Set gxMx = gxGr.MoveAbsolute(XWorld, YWorld, ZWorld, XRef, YRef, ZRef)
        
        Next
    
    Else
    
        For Each gxGr In gxSel
        
            Set gxMx = gxGr.MoveAbsolute(XUcs, YUcs, ZUcs)
        
        Next
    
    End If

    gxSel(0).Select
Err:
End Sub


Private Sub GetRefPoint(gxObj As Object, XRef As Double, YRef As Double, ZRef As Double)

    Dim gxBBox As BoundingBox
    Dim gxVrtMax As Vertex
    Dim gxVrtMin As Vertex

    Set gxBBox = gxObj.CalcBoundingBox

    Set gxVrtMin = gxBBox.Min
    Set gxVrtMax = gxBBox.Max
        
    XRef = gxVrtMin.X + (gxVrtMax.X - gxVrtMin.X) / 2
    YRef = gxVrtMin.Y + (gxVrtMax.Y - gxVrtMin.Y) / 2
    ZRef = gxVrtMin.Z + (gxVrtMax.Z - gxVrtMin.Z) / 2

End Sub

Public Sub RotateSelection(angle As Double, bUseSelBBox)

    Dim XRef As Double
    Dim YRef As Double
    Dim ZRef As Double
    
    Dim gxGr As Graphic
    Dim gxSel As Selection
    Dim gxMx As Matrix
    
    On Error GoTo Err
    
    
    angle = angle * PI / 180
    
    Set gxSel = gxDwg.Selection
    
    If (bUseSelBBox) Then
    
        GetRefPoint gxSel, XRef, YRef, ZRef
    
        For Each gxGr In gxSel
        
            Set gxMx = gxGr.RotateAxis(angle, , , , XRef, YRef, ZRef)
        
        Next
    
    Else
    
        For Each gxGr In gxSel
        
            Set gxMx = gxGr.RotateAxis(angle)
        
        Next
    
    End If

    gxSel(0).Select
Err:
End Sub

Public Sub ExplodeSelection()

    Dim gxSel As Selection
    Dim gxGr As Graphic
    
    On Error GoTo Err
    
    Set gxSel = gxDwg.Selection
    
    For Each gxGr In gxSel
        gxGr.Explode
    Next

    If gxSel.Count() > 0 Then
        gxSel(0).Select
    End If

Err:
End Sub

Public Sub CreateGroupFromSelection()

    Dim gxGroup As Graphic
    Dim gxGr As Graphic
    Dim gxGrs As Graphics
    Dim gxGrsGroup As Graphics
    Dim gxSel As Selection
    
    
    On Error GoTo Err
    Set gxGrs = gxDwg.Graphics
    Set gxGroup = gxGrs.Add(imsiGroup)
    Set gxGrsGroup = gxGroup.Graphics
    
    Set gxSel = gxDwg.Selection

    For Each gxGr In gxSel
    
        gxGrs.Remove gxGr.Index
    
        gxGrsGroup.AddGraphic gxGr
    Next

    Set gxGrsGroup = Nothing
    Set gxGrs = Nothing

    gxGroup.Select
    
    Exit Sub
Err:
    On Error Resume Next
    Set gxGrsGroup = Nothing
    Set gxGrs = Nothing
    gxGroup.Delete

End Sub

Public Sub OpenDrawing()
    Dim drname As String
    On Error Resume Next
    Err.Clear
    drname = gxApp.GetOpenFilename
    If Err.Number = 0 Then
        gxApp.Drawings.Open drname
        Err.Clear
        Exit Sub
    End If
    MsgBox Err.Description
    Err.Clear
End Sub

Public Sub SaveDrawing()
    Dim drname As String
    On Error Resume Next
    Err.Clear
    drname = gxApp.GetSaveAsFilename
    If Err.Number = 0 Then
        gxDwg.SaveAs drname
        Err.Clear
        Exit Sub
    End If
    MsgBox Err.Description
    Err.Clear
End Sub


Public Sub InsertDrawing()
    Dim pDwgEx As DwgEx
    Set pDwgEx = New DwgEx
    Dim drname As String
    Dim Gr As Graphic
    On Error Resume Next
    Err.Clear
    drname = gxApp.GetOpenFilename
    If Err.Number <> 0 Then
        MsgBox Err.Description
        Err.Clear
        Exit Sub
    End If
    Err.Clear
    pDwgEx.OpenFile drname
    Set Gr = pDwgEx.RunMerge(gxDwg, False)
' Now you can place the result graphic(group) in place you want
    gxView.Refresh
    Gr.Update
    Gr.Draw gxView
Set Gr = Nothing

End Sub

Public Sub closeDrawing()
    gxDwg.Close False
    Set gxView = Nothing
    Set gxDwg = Nothing
    frmTCADX.pbxView.Refresh
    frmTCADX.DisableButtons4
    frmTCADX.DisableButtons2
End Sub

Public Sub SpaceModeButtonControl()
    If gxDwg.Properties("TileMode") = 1 Then
        frmTCADX.btnSpaceMode.Caption = "M" ' model space
    Else
        frmTCADX.btnSpaceMode.Caption = "P"  ' paperspace
    End If
End Sub

Public Sub ChangeSpaceMode()
    If gxDwg.Properties("TileMode") = imsiModelSpace Then
        gxDwg.Properties("TileMode") = imsiPaperSpace
        gxView.SpaceMode = imsiPaperSpace
    Else
        gxDwg.Properties("TileMode") = imsiModelSpace
        gxView.SpaceMode = imsiModelSpace
    End If
    gxView.ZoomToExtents
    frmTCADX.pbxView.Refresh
    Call SpaceModeButtonControl
End Sub
